/*
LoggingServiceListener.java
Copyright (C) 2010  Belledonne Communications, Grenoble, France

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

package org.linphone.core;

import androidx.annotation.Nullable;
import androidx.annotation.NonNull;

/**
* Listener for LinphoneLoggingService. <br/>
* <br/>
*/
public interface LoggingServiceListener {
    /**
    * Type of callbacks called each time liblinphone write a log message. <br/>
    * <br/>
    * @param logService A pointer on the logging service singleton.   <br/>
    * @param domain A string describing which sub-library of liblinphone the message<br/>
    * is coming from.   <br/>
    * @param level Verbosity LinphoneLogLevel of the message. <br/>
    * @param message Content of the message.   <br/>
    */
    public void onLogMessageWritten(@NonNull LoggingService logService, @NonNull String domain, LogLevel level, @NonNull String message);

}